﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module

Sub Class_Globals
	Private fx As JFX
	Public factorMeters_to_Feet As Double = 3.2808399
	Private pnMain As Pane
	Private Center As Double
	Private TDiam As Double 
	Private pnPanel As JavaObject 
	Private cvPanel As Canvas 
	Private cMold As JavaObject 
	Private Scale As Double	
	Private TxtForecolor As Paint = fx.Colors.black
	Private tmAltim As Timer 
	Private AltValue, AltOldValue As Int
	Private GradColor(2) As Paint 
	Private fnt As Font 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Diam As Double)
	TDiam = Diam
	Scale = 240/TDiam
	pnMain.Initialize("")
	cvPanel.Initialize("")
	pnMain.PrefHeight = TDiam
	pnMain.PrefWidth = TDiam
	Center = TDiam/2
	GradColor(0) = fx.Colors.RGB(11, 84, 157)
	GradColor(1) = fx.Colors.RGB(114, 180, 228)
	tmAltim.Initialize("tmAltim", 10)
	tmAltim.Enabled = False 
	makeAltimeter
End Sub
Public Sub showAltimeter(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub
Private Sub makeAltimeter
	Dim Radius As Double
	Dim SList As List
	SList.Initialize
	Dim Stp(2) As JavaObject 
	Radius = 110/Scale
	
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, GradColor(0)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, GradColor(1)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(1.0, 0.5, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("REPEAT")),SList))	
	
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.InnerShadow",Null)
	Effect.RunMethod("setChoke",Array(0.31))
	Effect.RunMethod("setRadius", Array(34.5))
	Effect.RunMethod("setHeight", Array(120.0/Scale))
	Effect.RunMethod("setWidth", Array(120.0/Scale))
	pnPanel.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	pnPanel.RunMethod("setFill", Array(LinearGradient))
	pnPanel.RunMethod("setEffect",Array(Effect))

	Radius = 120/Scale
	Dim strkWdt As Double = 20/Scale
	cMold.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	cMold.RunMethod("setFill", Array(fx.Colors.Transparent))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	cMold.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	cMold.RunMethod("setStrokeWidth",Array (strkWdt))
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(242, 236, 236)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(47, 45, 45)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.4476190476190476, 0.34285714285714286, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	cMold.RunMethod("setStroke", Array(LinearGradient))
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.Lighting",Null)
	Effect.RunMethod("setDiffuseConstant",Array(1.0))
	Effect.RunMethod("setSpecularConstant",Array(0.3))
	Effect.RunMethod("setSpecularExponent",Array(22.8))
	Effect.RunMethod("setSurfaceScale",Array(2.5))
	cMold.RunMethod("setEffect",Array(Effect))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))

	pnMain.AddNode(pnPanel,-1, -1, -1, -1)
	pnMain.AddNode(cvPanel, 0,0,TDiam,TDiam)
	pnMain.AddNode(cMold,-1, -1, -1, -1)
	DrawPanel

End Sub
Private Sub DrawPanel
    Dim x As Double, y As Double, TickCount As Short, TickVal As Short
    Dim cStart As Short, cEnd As Short, PicHgt As Double, Stroke As Short
    Dim Radius As Double, strk(4) As Double, cValue As Int
	Dim cFeet As String
	strk(0)= 17/Scale
	strk(1)= 12/Scale
	strk(2)= 7/Scale
	strk(3)= 25/Scale
	fnt = fx.CreateFont("system", 13/Scale,False,False)
	cvPanel.ClearRect(0,0,TDiam,TDiam)
	cvPanel.DrawLine(Center, Center-100/Scale, Center, Center+100/Scale ,TxtForecolor,1)
	cvPanel.DrawLine(Center-100/Scale, Center, Center+100/Scale, Center ,fx.Colors.red,1)
	cvPanel.DrawTextRotated ("Meters",Center-85/Scale, Center,fnt,TxtForecolor,"CENTER",-90)
	Radius = Center-(100/Scale)
	PicHgt =  (200/Scale)/60
	cValue = AltOldValue' Mod 360
    cStart = cValue + 30
    cEnd = cValue - 30
	cFeet = NumberFormat(cValue*factorMeters_to_Feet,1,0)
	cvPanel.DrawText(cValue & " Meters",Center+15/Scale, Center-4/Scale,fnt,TxtForecolor,"LEFT")
	cvPanel.DrawText(cFeet & " Feet",Center+15/Scale, Center+ 15/Scale,fnt,TxtForecolor,"LEFT")
    TickVal = cStart
	For TickCount = 0 To 60
		y = Radius + (PicHgt * TickCount)
        Stroke = TickVal Mod 10
        If Stroke = 0 Then 
			cvPanel.DrawLine(Center-strk(0),y,Center,y, TxtForecolor, 0.8)
			cvPanel.DrawText(TickVal, Center-strk(3), y +(10/Scale)/2, fnt,TxtForecolor,"RIGHT")
		End If
        Stroke = TickVal Mod 5
        If Stroke = 0 Then
            cvPanel.DrawLine(Center-strk(1),y,Center,y,TxtForecolor,0.8)
        Else
			cvPanel.DrawLine(Center-strk(2),y,Center,y, TxtForecolor, 0.8)
        End If		
        TickVal = TickVal - 1
	Next
End Sub
Public Sub SetValue(Meters As Double)
	AltValue = Meters
	tmAltim.Enabled =True
End Sub
Public Sub Change_TextColor(clr As Paint)
	TxtForecolor = clr
	DrawPanel
End Sub
Public Sub Change_GradColor(clr0 As Paint, clr1 As Paint)
	pnMain.RemoveAllNodes 
	GradColor(0) = clr0
	GradColor(1) = clr1
	makeAltimeter
End Sub
Public Sub GetMeters() As Int
	Return AltValue
End Sub
Private Sub tmAltim_Tick
	If AltValue = AltOldValue Then
		tmAltim.Enabled = False
		Return
	End If
	Dim stp, vl As Short
	Dim ft As Short = Abs(AltOldValue - AltValue)
	vl = ft/100
	If vl<1 Then vl=1
	If AltValue > AltOldValue Then
		stp=vl
	Else
		stp = -vl
	End If	
	AltOldValue = AltOldValue + stp
	DrawPanel
End Sub