﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Center As Double
	Private TDiam As Double 
	Private pnPanel As JavaObject 
	Private cvPanel As Canvas 
	Private cMold As JavaObject 
	Private cCent As JavaObject 
	Private Indicator As JavaObject 
	Private Scale As Double
	Private FatorMph As Double = 1.609344

	Private tmSpeed As Timer 
	Private SpeedValue, SpeedOldValue As Int
	Private turn As Boolean =  False 
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Diam As Double)
	TDiam = Diam
	pnMain.Initialize("")
	cvPanel.Initialize("")
	pnMain.PrefHeight = TDiam
	pnMain.PrefWidth = TDiam
	Center = TDiam/2
	tmSpeed.Initialize("tmSpeed", 10)
	tmSpeed.Enabled = False 
	makeSpeed
End Sub
Public Sub SetValue(vl As Double)
	SpeedValue = vl
	If SpeedValue<0 Then SpeedValue = SpeedValue + 360
	tmSpeed.Enabled =True
End Sub
Private Sub makeSpeed
	Scale = 240/TDiam
	Dim Radius As Double
	Dim SList As List
	SList.Initialize
	Dim Stp(2) As JavaObject 
	Radius = 110/Scale
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.InnerShadow",Null)
	Effect.RunMethod("setChoke",Array(0.31))
	Effect.RunMethod("setRadius", Array(34.5))
	Effect.RunMethod("setHeight", Array(120.0/Scale))
	Effect.RunMethod("setWidth", Array(120.0/Scale))
	pnPanel.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	pnPanel.RunMethod("setFill", Array(fx.Colors.White ))
	pnPanel.RunMethod("setEffect",Array(Effect))

	Radius = 120/Scale
	Dim strkWdt As Double = 20/Scale
	cMold.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	cMold.RunMethod("setFill", Array(fx.Colors.Transparent))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	cMold.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	cMold.RunMethod("setStrokeWidth",Array (strkWdt))
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(242, 236, 236)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(47, 45, 45)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.4476190476190476, 0.34285714285714286, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	cMold.RunMethod("setStroke", Array(LinearGradient))
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.Lighting",Null)
	Effect.RunMethod("setDiffuseConstant",Array(1.0))
	Effect.RunMethod("setSpecularConstant",Array(0.3))
	Effect.RunMethod("setSpecularExponent",Array(22.8))
	Effect.RunMethod("setSurfaceScale",Array(2.5))
	cMold.RunMethod("setEffect",Array(Effect))

	pnMain.AddNode(pnPanel,-1, -1, -1, -1)
	pnMain.AddNode(cvPanel, 0,0,TDiam,TDiam)
	pnMain.AddNode(cMold,-1, -1, -1, -1)

	Radius = 75/Scale
	Dim tx As String 
	Dim flg As Boolean 
	Dim compX As Double = 8/Scale
	Dim compY As Double = 5/Scale	

	Dim Points(10) As Double
	Points(0) = Center 
	Points(1) = Center - 50/Scale
	Points(2) = 7/Scale + Center
	Points(3) = Center 
	Points(4) = Center - 7/Scale
	Points(5) = Center	
	Points(6) = Center 
	Points(7) = Center - 50/Scale
	Points(8) = Center
	Points(9) = 50/Scale + Center 	
	Indicator.InitializeNewInstance("javafx.scene.shape.Polygon",Array(Points))
	Dim LinearGradient As JavaObject 
	Dim Stp(2) As JavaObject 
	Stp(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(7, 119, 178)))
	Stp(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(47, 45, 45)))
	SList.Clear 
	SList.Add(Stp(0))
	SList.Add(Stp(1))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(1.0, 0.0, 1.0, 1.0, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList))
	Indicator.RunMethod("setFill", Array(LinearGradient))
	Dim Effect As JavaObject 
	Effect.InitializeNewInstance("javafx.scene.effect.InnerShadow",Null)
	Effect.RunMethod("setChoke",Array(0.42))
	Effect.RunMethod("setRadius", Array(13.7075))
	Effect.RunMethod("setHeight", Array(41.76))
	Effect.RunMethod("setWidth", Array(15.07))
	Effect.RunMethod("setColor", Array(fx.Colors.RGB(64, 64, 64)))
	Indicator.RunMethod("setEffect",Array(Effect))
	pnMain.AddNode(Indicator,-1 ,-1 , -1, -1)
	DrawPanel
	Radius = 10/Scale
	cCent.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	cCent.RunMethod("setFill", Array(fx.Colors.RGB(233,233,233)))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	cCent.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	cMold.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	strkWdt = 2/Scale
	cCent.RunMethod("setStrokeWidth",Array (strkWdt))
	cCent.RunMethod("setStroke", Array(fx.Colors.DarkGray))
	pnMain.AddNode(cCent,-1 ,-1 , -1, -1)
	SpeedOldValue = 160
	SetValue(0)
End Sub
Private Sub DrawPanel
    Dim  TickCount, Tickval As Short
    Dim  Stroke As Short
    Dim  strk(5) As Double
	strk(0)= 13/Scale
	strk(1)= 28/Scale
	strk(2)= 7/Scale
	strk(3)= 25/Scale	
	strk(4)= 43/Scale
	Dim fz As Double = (11/Scale) 
	Dim fz1 As Double = (10/Scale) 
	Dim f As Font = fx.CreateFont("System", fz,False,False)
	Dim f1 As Font = fx.CreateFont("System", fz1,True,False)
	Dim NewPt(2) As PointApi 
	Dim Radius As Double  = 95/Scale
	For TickCount = 20 To 320
		Tickval = TickCount - 170
		NewPt(0)= new_pt(Tickval,Radius,Center,Center)
    	Stroke = TickCount Mod 10
        If Stroke = 0 Then 
			If (TickCount/10)Mod 2 <>0 Then
				NewPt(1) = new_pt(Tickval,Radius - strk(1),Center,Center)
			Else
				NewPt(1) = new_pt(Tickval,Radius - strk(0),Center,Center)
			End If
			cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray,0.5)
		Else If TickCount Mod 2 = 0 Then
			NewPt(1) = new_pt(Tickval,Radius - strk(2),Center,Center)
			cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y,fx.Colors.DarkGray,0.5)
		End If
        Stroke = TickCount Mod 20
        If Stroke = 0 Then
			NewPt(1) = new_pt(360-Tickval,Radius - strk(3),Center,Center)
			cvPanel.DrawTextRotated(TickCount, NewPt(1).x , NewPt(1).y, f, fx.Colors.DarkGray, "CENTER", TickCount-170)
		End If
	Next
 	For TickCount = 20 To 198
		Tickval = TickCount * FatorMph - 170
        Stroke = TickCount Mod 20
        If Stroke = 0 Then
			NewPt(1) = new_pt(360-Tickval,Radius - strk(4),Center,Center)
			cvPanel.DrawTextRotated(TickCount, NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount * FatorMph-170)
		Else If TickCount Mod 10 = 0 Then
			NewPt(1) = new_pt(360-Tickval,Radius - strk(4),Center,Center)
			cvPanel.DrawTextRotated(".", NewPt(1).x , NewPt(1).y, f1, fx.Colors.DarkGray, "CENTER", TickCount * FatorMph-170)
		End If		
	Next
	cvPanel.DrawText("Km/h",Center,80/Scale,f,fx.Colors.DarkGray,"CENTER")
	cvPanel.DrawText("Mph",Center,93/Scale,f1,fx.Colors.DarkGray,"CENTER")
	cvPanel.DrawCircle(Center,Center,66/Scale,fx.Colors.DarkGray,False,0.5)
	
End Sub
Public Sub showSpeed(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub

Private Sub setVel
	Dim fz As Double = (11/Scale) 
	Dim fz1 As Double = (10/Scale) 
	Dim f As Font = fx.CreateFont("System", fz,False,False)
	Dim f1 As Font = fx.CreateFont("System", fz1,True,False)
	cvPanel.ClearRect(Center-15/Scale, 140/Scale, 30/Scale,30/Scale)
	cvPanel.DrawText(SpeedOldValue & " K",Center,150/Scale,f,fx.Colors.DarkGray,"CENTER")
	Dim m As Int = SpeedOldValue/FatorMph
	cvPanel.DrawText(m & " M",Center,163/Scale,f1,fx.Colors.DarkGray,"CENTER")
End Sub
Private Sub tmSpeed_Tick
	If SpeedValue = SpeedOldValue Then
		tmSpeed.Enabled = False
		Return
	End If
	Dim stp As Double
	If SpeedValue > SpeedOldValue Then
		stp= 1
	Else
		stp = -1
	End If	
	SpeedOldValue = SpeedOldValue + stp
	setVel
	Dim angle As Int = SpeedOldValue - 170
	
	tx="-fx-rotate: " & angle
	Indicator.RunMethod("setStyle", Array(tx))
End Sub
Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
        Dim AngleRad As Double
		Dim pt As PointApi 
		nAngle = 90 + nAngle
        If nAngle > 360 Then nAngle = nAngle - 360
        AngleRad = nAngle * cPI / 180 'convert to rad
        If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
        pt.x = CX + (r) * Cos(AngleRad)
        pt.Y  = CY - (r) * Sin(AngleRad)
        Return pt
End Sub